"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;
  var tmpl = _ref.template;


  var handled = tmpl("{\n if (typeof(window.makitoo) !== \"undefined\") window.makitoo.report(\"handled\", BUILD, PROBE, E);\nCATCH\n}\n");

  var unhandled = tmpl("{\n  try {\n      BODY\n  } catch(ex) {\n if (typeof(window.makitoo) !== \"undefined\")\n       window.makitoo.handleException(\"unhandled\", BUILD, PROBE, ex);\n  }\n}");

  var callback = tmpl("{\n if (typeof(window.makitoo) !== \"undefined\") window.makitoo.report(\"callback\", BUILD, PROBE, E);\nBODY\n}");

  var buildid = Date.now();
  var getBuildId = function getBuildId(opts) {
    if (typeof opts !== "undefined" && opts.test) return 1;
    return buildid;
  };
  var probeid = 1;
  var generateProbe = function generateProbe(opts) {
    if (typeof opts !== "undefined" && opts.test) return 1;
    return probeid++;
  };

  return {
    visitor: {
      CatchClause: function CatchClause(path, state) {
        if (!path.node._generated) path.node.body = handled({
          BUILD: t.numericLiteral(getBuildId(state.opts)),
          PROBE: t.numericLiteral(generateProbe(state.opts)),
          E: path.node.param,
          CATCH: path.node.body.body });
      },

      FunctionExpression: {
        enter: function enter(path, state) {

          // Add error callback for parameters
          for (var i in path.node.params) {
            var param = path.node.params[i];
            if ('error' == param.name || 'err' == param.name) {
              path.node.body = callback({
                BUILD: t.numericLiteral(getBuildId(state.opts)),
                PROBE: t.numericLiteral(generateProbe(state.opts)),
                E: param,
                BODY: path.node.body.body
              });
            }
          }

          // Generate a try/catch
          path.node.body = unhandled({
            BUILD: t.numericLiteral(getBuildId(state.opts)),
            PROBE: t.numericLiteral(generateProbe(state.opts)),
            BODY: path.node.body.body
          });

          path.node.body.body[0].handler._generated = true;
        }
      }
    }
  };
};

module.exports = exports["default"];